
# line 2 "grammar.y"
/*
** This is a bare-bones prototype for an ANSI C parser.
**
** It is based on _The C Programming Language,
** Second Edition_, Kernighan and Ritchie, Printice Hall, 1988.
*/
#include <sys/types.h>
#include "lowlevel.h"
#include "host.h"
#include "hash.h"
#include "files.h"
#include "il.h"
#include "nodeop.h"
#include "types.h"

# line 18 "grammar.y"
typedef union  {
    int val;
	node_t *nod;
	symbol_t *sym;
	typeinfo_t *typ;
} YYSTYPE;
# define BAD_TOKEN 257
# define INTEGER_CONSTANT 258
# define CHARACTER_CONSTANT 259
# define FLOATING_CONSTANT 260
# define ENUMERATION_CONSTANT 261
# define IDENTIFIER 262
# define STRING 263
# define TYPEDEF_NAME 264
# define SIZEOF 265
# define PTR_OP 266
# define INC_OP 267
# define DEC_OP 268
# define LEFT_OP 269
# define RIGHT_OP 270
# define LE_OP 271
# define GE_OP 272
# define EQ_OP 273
# define NE_OP 274
# define AND_OP 275
# define OR_OP 276
# define MUL_ASSIGN 277
# define DIV_ASSIGN 278
# define MOD_ASSIGN 279
# define ADD_ASSIGN 280
# define SUB_ASSIGN 281
# define LEFT_ASSIGN 282
# define RIGHT_ASSIGN 283
# define AND_ASSIGN 284
# define XOR_ASSIGN 285
# define OR_ASSIGN 286
# define TYPEDEF 287
# define EXTERN 288
# define STATIC 289
# define AUTO 290
# define REGISTER 291
# define CHAR 292
# define SHORT 293
# define INT 294
# define LONG 295
# define SIGNED 296
# define UNSIGNED 297
# define FLOAT 298
# define DOUBLE 299
# define CONST 300
# define VOLATILE 301
# define VOID 302
# define STRUCT 303
# define UNION 304
# define ENUM 305
# define ELIPSIS 306
# define DOTDOT 307
# define CASE 308
# define DEFAULT 309
# define IF 310
# define SWITCH 311
# define WHILE 312
# define DO 313
# define FOR 314
# define GOTO 315
# define CONTINUE 316
# define BREAK 317
# define RETURN 318
# define THEN 319
# define ELSE 320
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
typedef int yytabelem;
# define YYERRCODE 256

# line 681 "grammar.y"

yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 7,
-1, 3,
	287, 9,
	-2, 1,
-1, 7,
	287, 9,
	-2, 1,
-1, 11,
	262, 31,
	287, 9,
	59, 31,
	44, 31,
	40, 31,
	41, 31,
	91, 31,
	42, 31,
	-2, 1,
-1, 12,
	262, 33,
	287, 9,
	59, 33,
	44, 33,
	40, 33,
	41, 33,
	91, 33,
	42, 33,
	-2, 1,
-1, 13,
	262, 35,
	287, 9,
	59, 35,
	44, 35,
	40, 35,
	41, 35,
	91, 35,
	42, 35,
	-2, 1,
-1, 26,
	61, 2,
	-2, 67,
-1, 27,
	40, 3,
	-2, 10,
-1, 36,
	287, 9,
	123, 21,
	-2, 1,
-1, 51,
	40, 3,
	-2, 11,
-1, 63,
	123, 5,
	-2, 1,
-1, 75,
	40, 3,
	-2, 10,
-1, 88,
	123, 5,
	-2, 60,
-1, 135,
	40, 3,
	-2, 11,
-1, 173,
	262, 70,
	58, 70,
	40, 70,
	41, 70,
	91, 70,
	42, 70,
	-2, 1,
-1, 174,
	262, 72,
	58, 72,
	40, 72,
	41, 72,
	91, 72,
	42, 72,
	-2, 1,
-1, 190,
	59, 4,
	44, 4,
	61, 4,
	40, 4,
	91, 4,
	-2, 98,
-1, 195,
	287, 9,
	-2, 1,
-1, 197,
	125, 6,
	-2, 1,
-1, 253,
	59, 4,
	44, 4,
	61, 4,
	40, 4,
	91, 4,
	-2, 97,
-1, 255,
	59, 4,
	44, 4,
	61, 4,
	40, 4,
	91, 4,
	-2, 99,
-1, 268,
	125, 6,
	-2, 1,
	};
# define YYNPROD 245
# define YYLAST 682
yytabelem yyact[]={

   122,   175,    96,    60,    39,   117,   313,   110,   290,   118,
   119,   279,   120,    18,    19,    20,    21,   265,    29,    28,
    30,    31,    32,   172,    53,    24,    25,   235,   150,   156,
   157,    56,   254,    57,   152,   162,   163,    58,    59,    26,
   141,    55,    65,    66,    64,    29,    75,    30,    31,    32,
    27,   260,    24,    25,   158,    27,   159,   296,   312,    28,
   262,    92,   289,    51,   146,    34,   178,    28,    42,    76,
    79,    97,   179,    16,    74,    91,    90,   144,    16,    46,
   104,   296,   194,   198,    34,   143,    28,   190,   296,   100,
    28,   169,   153,   121,   197,    67,   147,    70,    72,   102,
   311,    34,   267,    28,   170,   103,   322,    99,   281,   299,
    81,   142,    83,    34,   273,   203,   203,   177,   137,   122,
   101,   200,   145,   135,   117,   139,   110,   191,   118,   119,
    39,   120,   281,   154,   229,   330,   329,   189,   149,   281,
    69,   131,   280,   312,    28,    35,   204,   173,    94,   302,
   147,    12,   319,   138,    82,    12,   164,   331,   165,    12,
    12,    12,   301,   280,   310,    28,   257,    87,   280,    18,
    19,    20,    21,   134,    29,    14,    30,    31,    32,    45,
   122,    24,    25,   283,    12,   117,   109,   110,   247,   118,
   119,   107,   120,   281,    44,   272,   271,   202,   298,    91,
    90,   256,   249,   259,    40,   106,    97,   270,     8,   148,
   201,   305,   121,   208,   281,   309,    47,    48,    49,   281,
    45,    84,   229,   136,   328,   126,   127,   128,   129,   123,
   125,   327,   115,   134,   112,   113,   274,   215,   216,   266,
   231,   151,   211,   236,   237,   238,   239,   240,   241,   242,
   243,   244,   245,   276,   213,   209,   140,   205,   282,   210,
    29,   214,    30,    31,    32,   160,   161,    24,    25,    97,
   303,   325,   193,   121,   212,   147,   307,    24,    25,    33,
   252,   263,   246,    97,   315,   297,   287,    33,   288,   269,
   308,   286,   180,   181,   182,   268,   108,   176,   292,   183,
   185,   278,   187,    33,    97,   321,    33,   308,   193,   316,
    33,    97,   324,    18,    19,    20,    21,   326,    29,   320,
    30,    31,    32,    33,   261,    24,    25,   293,   295,   304,
   287,   288,   277,   300,   253,    33,    74,   176,   306,    22,
   291,   266,   135,    12,   126,   127,   128,   129,   123,   125,
   278,   115,   263,   112,   113,   199,   223,   224,   228,   294,
   133,   317,   105,   318,   176,   176,   295,   122,   221,   222,
   196,   176,   117,    85,   110,   176,   118,   119,   122,   120,
   130,   168,    -1,   117,    88,   110,   166,   118,   119,   122,
   120,   167,   284,   155,   117,   285,   110,    80,   118,   119,
   258,   120,    15,    89,    89,   126,   127,   128,   129,   123,
   125,   186,   115,   122,   112,   113,   176,    -1,   117,    52,
   110,   176,   118,   119,   122,   120,    86,   323,    10,   117,
    -1,   110,    68,   118,   119,   122,   120,    41,   314,    43,
   117,    -1,   188,     9,   118,   119,   122,   120,    50,    93,
    -1,   117,    -1,   184,    -1,   118,   119,    37,   120,   255,
   121,     5,   256,   225,   226,   227,   171,   230,    77,    38,
   229,   121,   176,    95,     6,     2,    17,   195,     3,   148,
     1,   174,   121,   264,   207,    13,   206,   248,    98,    13,
   111,   116,   124,    13,    13,    13,     7,     4,    78,   192,
    61,    62,    36,    54,    63,   234,   121,   114,    11,    71,
    73,    23,     0,     0,     0,     0,     0,   121,    13,    89,
    89,   217,   218,   219,   220,   275,     0,     0,   121,   232,
   233,     0,     0,     0,     0,     0,     0,     0,     0,   121,
     0,     0,     0,     0,   171,     0,     0,     0,     0,     0,
     0,     0,     0,   132,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   250,   251,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   126,   127,   128,   129,   123,   125,     0,   115,
     0,   112,   113,   126,   127,   128,   129,   123,   125,     0,
   115,     0,   112,   113,   126,   127,   128,   129,   123,   125,
     0,   115,     0,   112,   113,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   126,   127,
   128,   129,   123,   125,     0,   115,     0,   112,   113,   126,
   127,   128,   129,   123,   125,     0,   115,     0,   112,   113,
   126,   127,   128,   129,   123,   125,     0,   115,     0,   112,
   113,   126,   127,   128,   129,   123,   125,    13,   115,     0,
   112,   113 };
yytabelem yypact[]={

 -1000, -1000, -1000,    25, -1000, -1000, -1000,  -119,    61,   135,
 -1000,  -275,  -275,  -275, -1000, -1000,    73,  -263, -1000, -1000,
 -1000, -1000,  -261, -1000, -1000, -1000, -1000,    49,   -23, -1000,
 -1000, -1000, -1000, -1000,    61, -1000,  -275, -1000, -1000, -1000,
    61, -1000,    95,   176, -1000,    61, -1000, -1000, -1000, -1000,
 -1000,    49, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000,  -186,   -62, -1000, -1000,    87, -1000,   380,
   340,   -23, -1000, -1000,   319,    49,    73,     7, -1000, -1000,
    -7, -1000, -1000,    94, -1000, -1000, -1000,     2, -1000,  -224,
 -1000, -1000,  -185,    -1,   356, -1000,    45, -1000,   -35,  -241,
   -32,    39,   355,  -244,    -6,  -234,   113,   344, -1000, -1000,
   -33,    26,   413,   413,   391,   402, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
    46, -1000, -1000, -1000,   330,    49, -1000, -1000, -1000,  -248,
    -2, -1000,    72, -1000,    85,  -185, -1000, -1000,   356, -1000,
   391,   391,   391,   391,   391,   391,   391,   391,   391,   391,
   391,   391,   391,   391,   391,   391,   391,   391,   391,   317,
   426, -1000, -1000,  -248,  -248, -1000,   -34,   391,   147,  -186,
  -186, -1000, -1000, -1000,   391, -1000, -1000, -1000,   -33,   293,
 -1000,   418,   122, -1000, -1000,  -275,    10,  -248, -1000,    44,
  -248, -1000, -1000,  -185,   391,    71, -1000,    70, -1000,   178,
  -241,   -32,    39,   355,  -244,    -6,    -6,  -234,  -234,  -234,
  -234,   113,   113,   344,   344, -1000, -1000, -1000,   391,   391,
 -1000,   123, -1000, -1000,   391, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000, -1000,    90, -1000,   351, -1000,
 -1000, -1000,   250, -1000, -1000, -1000,  -200,  -298,    48,   244,
 -1000,   157,   -16, -1000,   118, -1000,    91,   391,  -248, -1000,
 -1000, -1000, -1000,    86,   391, -1000, -1000, -1000,   128,   124,
   102,   345, -1000, -1000, -1000,   391, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000, -1000,    41,    17, -1000, -1000, -1000,
    93,    44,   391, -1000,   -19, -1000, -1000, -1000,   124,   334,
   230,   190, -1000,   183, -1000,    43, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000,    42, -1000,   116, -1000, -1000, -1000,
 -1000, -1000 };
yytabelem yypgo[]={

     0,   511,   481,   509,   508,   507,   505,   504,   147,    91,
   503,   355,   204,   461,   502,    85,   111,   501,   500,    94,
    83,    82,   499,     6,   497,   496,   492,   384,   127,     2,
   491,    23,   104,   490,   186,   296,   191,   205,   362,    80,
   105,    99,   120,    89,   107,   488,     1,   487,    64,   484,
    39,    46,   175,   439,    17,   483,    69,   100,    11,   428,
   402,   480,   339,    68,    97,    32,   167,    60,   478,   477,
   476,   432,   373,   475,   474,   145,   468,   457,   454,   452,
   450,   441,   430,   417,   397,   382 };
yytabelem yyr1[]={

     0,    62,    63,    64,    65,    66,    67,    68,    69,    70,
    71,    72,    27,    27,    27,    61,    61,    73,    73,    73,
    24,    76,    24,    25,    25,    75,    13,    13,    74,    14,
    14,    12,    12,    12,    12,    12,    12,     4,     4,     4,
     4,     4,     8,     8,    10,    10,    10,    10,    10,    10,
    10,    10,     1,     1,     1,     1,     2,     2,    18,    18,
    18,     7,     7,    19,    19,    53,    53,    52,    52,    20,
    11,    11,    11,    11,    55,    55,    54,    54,    54,    17,
    17,    17,    16,    16,    15,    15,    50,    50,    51,    51,
    51,    51,    51,    51,    51,    59,    59,    60,    60,    60,
    56,    56,    56,    56,     3,     3,    23,    23,    22,    22,
    21,    21,    21,    28,    28,    48,    48,    48,    49,    49,
     9,     9,    57,    57,    57,    58,    58,    58,    58,    58,
    58,    58,    58,    58,    78,    78,    78,    78,    78,    78,
    79,    79,    79,    80,    80,    84,    77,    85,    85,    81,
    81,    81,    82,    82,    82,    82,    82,    82,    82,    82,
    82,    82,    83,    83,    83,    83,    83,    32,    32,    31,
    31,     6,     6,     6,     6,     6,     6,     6,     6,     6,
     6,     6,    46,    46,    29,    45,    45,    44,    44,    43,
    43,    42,    42,    41,    41,    40,    40,    40,    39,    39,
    39,    39,    39,    38,    38,    38,    37,    37,    37,    36,
    36,    36,    36,    35,    35,    34,    34,    34,    34,    34,
    34,     5,     5,     5,     5,     5,     5,    33,    33,    33,
    33,    33,    33,    33,    33,    30,    30,    30,    30,    47,
    47,    26,    26,    26,    26 };
yytabelem yyr2[]={

     0,     0,     0,     1,     1,     0,     0,     0,     0,     0,
     0,     0,     7,     2,     2,     0,     4,     5,     5,     4,
     4,     1,     8,     5,     7,     4,     7,     9,     4,     2,
     5,     3,     5,     2,     5,     3,     5,     5,     3,     3,
     3,     3,     5,     3,     3,     3,     3,     3,     3,     2,
     3,     3,     3,     3,     3,     3,     3,     3,    13,    15,
     5,     3,     3,     2,     5,     2,     7,     2,    11,     9,
     3,     5,     3,     5,     2,     7,     2,     5,     7,     9,
    11,     5,     2,     7,     3,     7,     4,     7,     2,     7,
     7,     9,    13,    11,    13,     4,     7,    11,     9,    11,
     3,     5,     5,     7,     2,     5,     2,     7,     2,     7,
     9,     7,     9,     2,     7,     2,     7,     9,     2,     7,
     4,     7,     2,     2,     5,     7,     5,     7,     7,     9,
     5,     7,     7,     9,     2,     2,     2,     2,     2,     2,
     6,     8,     6,     2,     4,     1,     6,     2,     4,    10,
    14,    10,    10,    14,    12,    14,    14,    16,    14,    16,
    16,    18,     6,     4,     4,     4,     6,     2,     7,     2,
     7,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     2,    11,     2,     2,     7,     2,     7,     2,
     7,     2,     7,     2,     7,     2,     7,     7,     2,     7,
     7,     7,     7,     2,     7,     7,     2,     7,     7,     2,
     7,     7,     7,     2,     9,     2,     5,     5,     5,     5,
     9,     3,     3,     3,     3,     3,     3,     2,     9,     7,
     9,     7,     7,     5,     5,     2,     2,     2,     7,     2,
     7,     2,     2,     2,     2 };
yytabelem yychk[]={

 -1000,   -61,   -73,   -68,   -24,   -13,   -74,   -25,   -12,   -53,
   -59,    -4,    -8,    -2,   -52,   -60,   -56,   -70,   288,   289,
   290,   291,   -62,    -1,   300,   301,   -50,   -51,    42,   293,
   295,   296,   297,   262,    40,   -75,   -14,   -77,   -13,   123,
   -12,   -59,   -63,   -53,    59,    44,   -63,   -12,   -12,   -12,
   -71,   -51,   -60,   287,   -10,   302,   292,   294,   298,   299,
   264,   -18,   -17,    -7,   305,   303,   304,   -63,   -71,    91,
   -64,    -3,   -56,    -2,   -50,   -51,   -56,   -76,   -13,   -65,
   -84,   -63,    59,   -63,   -52,   -72,   -72,   -66,   -27,   -62,
   262,   261,   123,   -27,    61,    93,   -29,   -46,   -45,   -44,
   -43,   -42,   -41,   -40,   -39,   -38,   -37,   -36,   -35,   -34,
    40,   -33,   267,   268,    -5,   265,   -30,    38,    42,    43,
    45,   126,    33,   262,   -26,   263,   258,   259,   260,   261,
    40,   -56,    -2,    41,   -64,   -51,   -75,   125,    59,   123,
   -66,   264,   -16,   -15,   262,   123,   -48,   -46,   123,    93,
    63,   276,   275,   124,    94,    38,   273,   274,    60,    62,
   271,   272,   269,   270,    43,    45,    42,    47,    37,    -9,
   -32,   -11,   -31,    -8,    -2,   -46,   -34,    91,    40,    46,
   266,   267,   268,   -34,    40,   -34,   -35,   -34,    40,   -23,
    41,   -28,   -22,   262,   -21,   -69,    40,   -19,   -20,   -11,
   123,   -63,   125,    44,    61,   -16,   -62,   -49,   -48,   -32,
   -44,   -43,   -42,   -41,   -40,   -39,   -39,   -38,   -38,   -38,
   -38,   -37,   -37,   -36,   -36,   -35,   -35,   -35,    41,    44,
    41,   -63,   -11,   -11,    -6,    61,   277,   278,   279,   280,
   281,   282,   283,   284,   285,   286,   -32,    41,   -47,   -31,
   -27,   -27,    -9,    41,   -65,    41,    44,    44,   -12,   -23,
    41,   -28,   -67,   -20,   -55,   -54,   -50,    58,   -19,   -15,
   -29,   125,   125,    44,    58,   -35,   -31,   -57,   -56,   -58,
    40,    91,   -31,    93,    41,    44,    41,   -65,   -65,   262,
   306,   -21,   -50,   -63,   -57,   -56,    40,    41,    41,   125,
   -63,    44,    58,   -29,   -67,   125,   -48,   -46,   -58,    91,
    40,   -57,    41,   -23,    93,   -29,   -31,   -63,   -63,    59,
   -54,   -29,   125,    93,   -29,    41,   -23,    41,    41,    93,
    93,    41 };
yytabelem yydef[]={

    15,    -2,    16,    -2,    17,    18,    19,    -2,     2,     0,
     2,    -2,    -2,    -2,    65,    10,     0,     0,    38,    39,
    40,    41,     0,    43,    56,    57,    -2,    -2,   100,    52,
    53,    54,    55,    88,     0,    20,    -2,     4,    29,   145,
     2,     2,     0,     2,    28,     0,    23,    32,    34,    36,
    95,    -2,    11,    37,    42,    44,    45,    46,    47,    48,
    49,    50,    51,    -2,     1,    61,    62,     0,    86,     0,
     0,   101,   102,   104,     0,    -2,     0,     0,    30,    25,
     0,    24,    26,     0,    66,    87,    96,     0,    -2,     0,
    13,    14,     0,    81,     0,    90,     0,   184,   182,   185,
   187,   189,   191,   193,   195,   198,   203,   206,   209,   213,
     1,   215,     0,     0,     0,     0,   227,   221,   222,   223,
   224,   225,   226,   235,   236,   237,   241,   242,   243,   244,
     8,   103,   105,    89,     0,    -2,    22,   146,    27,     1,
     0,     2,     0,    82,    84,     0,     1,   115,     0,    91,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     2,   167,    -2,    -2,   169,   213,     0,     0,     1,
     1,   233,   234,   216,     0,   217,   218,   219,     1,     0,
    -2,     0,   106,   113,   108,    -2,     8,    -2,    63,     0,
     1,    12,    79,     0,     0,     0,    68,     0,   118,     0,
   186,   188,   190,   192,   194,   196,   197,   199,   200,   201,
   202,   204,   205,   207,   208,   210,   211,   212,     0,     0,
   238,   120,    71,    73,     0,   171,   172,   173,   174,   175,
   176,   177,   178,   179,   180,   181,     0,   229,     0,   239,
   231,   232,     0,    -2,    93,    -2,     0,     8,     2,     0,
     4,     0,     0,    64,     2,    74,    76,     0,    -2,    83,
    85,    80,   116,     0,     0,   214,   168,   121,   122,   123,
     8,     0,   170,   228,   230,     0,   220,    92,    94,   114,
   107,   109,     2,   111,     2,   122,     8,     4,     4,    58,
     0,     0,     0,    77,     0,   117,   119,   183,   124,     0,
     8,     0,   130,     0,   126,     0,   240,   110,   112,    69,
    75,    78,    59,   128,     0,   132,     0,   125,   131,   127,
   129,   133 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"BAD_TOKEN",	257,
	"INTEGER_CONSTANT",	258,
	"CHARACTER_CONSTANT",	259,
	"FLOATING_CONSTANT",	260,
	"ENUMERATION_CONSTANT",	261,
	"IDENTIFIER",	262,
	"STRING",	263,
	"TYPEDEF_NAME",	264,
	"SIZEOF",	265,
	"PTR_OP",	266,
	"INC_OP",	267,
	"DEC_OP",	268,
	"LEFT_OP",	269,
	"RIGHT_OP",	270,
	"LE_OP",	271,
	"GE_OP",	272,
	"EQ_OP",	273,
	"NE_OP",	274,
	"AND_OP",	275,
	"OR_OP",	276,
	"MUL_ASSIGN",	277,
	"DIV_ASSIGN",	278,
	"MOD_ASSIGN",	279,
	"ADD_ASSIGN",	280,
	"SUB_ASSIGN",	281,
	"LEFT_ASSIGN",	282,
	"RIGHT_ASSIGN",	283,
	"AND_ASSIGN",	284,
	"XOR_ASSIGN",	285,
	"OR_ASSIGN",	286,
	"TYPEDEF",	287,
	"EXTERN",	288,
	"STATIC",	289,
	"AUTO",	290,
	"REGISTER",	291,
	"CHAR",	292,
	"SHORT",	293,
	"INT",	294,
	"LONG",	295,
	"SIGNED",	296,
	"UNSIGNED",	297,
	"FLOAT",	298,
	"DOUBLE",	299,
	"CONST",	300,
	"VOLATILE",	301,
	"VOID",	302,
	"STRUCT",	303,
	"UNION",	304,
	"ENUM",	305,
	"ELIPSIS",	306,
	"DOTDOT",	307,
	"CASE",	308,
	"DEFAULT",	309,
	"IF",	310,
	"SWITCH",	311,
	"WHILE",	312,
	"DO",	313,
	"FOR",	314,
	"GOTO",	315,
	"CONTINUE",	316,
	"BREAK",	317,
	"RETURN",	318,
	"THEN",	319,
	"ELSE",	320,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"NS_ntd : /* empty */",
	"NS_td : /* empty */",
	"NS_scope_push : /* empty */",
	"NS_scope_pop : /* empty */",
	"NS_struct_push : /* empty */",
	"NS_struct_pop : /* empty */",
	"NS_id : /* empty */",
	"NS_new_parm : /* empty */",
	"NS_is_typedef : /* empty */",
	"NS_direct_decl : /* empty */",
	"NS_ptr_decl : /* empty */",
	"identifier : NS_ntd TYPEDEF_NAME NS_td",
	"identifier : IDENTIFIER",
	"identifier : ENUMERATION_CONSTANT",
	"translation_unit : /* empty */",
	"translation_unit : translation_unit external_declaration",
	"external_declaration : NS_id function_definition",
	"external_declaration : NS_id declaration",
	"external_declaration : NS_id untyped_declaration",
	"function_definition : function_head function_body",
	"function_definition : function_head declaration_list",
	"function_definition : function_head declaration_list function_body",
	"function_head : function_declarator NS_td",
	"function_head : declaration_specifiers function_declarator NS_td",
	"function_body : compound_statement NS_scope_pop",
	"declaration : declaration_specifiers NS_td ';'",
	"declaration : declaration_specifiers init_declarator_list NS_td ';'",
	"untyped_declaration : init_declarator_list ';'",
	"declaration_list : declaration",
	"declaration_list : declaration_list declaration",
	"declaration_specifiers : storage_class_specifier",
	"declaration_specifiers : storage_class_specifier declaration_specifiers",
	"declaration_specifiers : type_specifier",
	"declaration_specifiers : type_specifier declaration_specifiers",
	"declaration_specifiers : type_qualifier",
	"declaration_specifiers : type_qualifier declaration_specifiers",
	"storage_class_specifier : NS_is_typedef TYPEDEF",
	"storage_class_specifier : EXTERN",
	"storage_class_specifier : STATIC",
	"storage_class_specifier : AUTO",
	"storage_class_specifier : REGISTER",
	"type_specifier : NS_ntd actual_type_specifier",
	"type_specifier : type_adjective",
	"actual_type_specifier : VOID",
	"actual_type_specifier : CHAR",
	"actual_type_specifier : INT",
	"actual_type_specifier : FLOAT",
	"actual_type_specifier : DOUBLE",
	"actual_type_specifier : TYPEDEF_NAME",
	"actual_type_specifier : struct_or_union_specifier",
	"actual_type_specifier : enum_specifier",
	"type_adjective : SHORT",
	"type_adjective : LONG",
	"type_adjective : SIGNED",
	"type_adjective : UNSIGNED",
	"type_qualifier : CONST",
	"type_qualifier : VOLATILE",
	"struct_or_union_specifier : struct_or_union NS_struct_push '{' struct_declaration_list NS_struct_pop '}'",
	"struct_or_union_specifier : struct_or_union identifier NS_struct_push '{' struct_declaration_list NS_struct_pop '}'",
	"struct_or_union_specifier : struct_or_union identifier",
	"struct_or_union : STRUCT",
	"struct_or_union : UNION",
	"struct_declaration_list : struct_declaration",
	"struct_declaration_list : struct_declaration_list struct_declaration",
	"init_declarator_list : init_declarator",
	"init_declarator_list : init_declarator_list ',' init_declarator",
	"init_declarator : declarator",
	"init_declarator : declarator NS_td '=' initializer NS_ntd",
	"struct_declaration : specifier_qualifier_list struct_declarator_list NS_td ';'",
	"specifier_qualifier_list : type_specifier",
	"specifier_qualifier_list : type_specifier specifier_qualifier_list",
	"specifier_qualifier_list : type_qualifier",
	"specifier_qualifier_list : type_qualifier specifier_qualifier_list",
	"struct_declarator_list : struct_declarator",
	"struct_declarator_list : struct_declarator_list ',' struct_declarator",
	"struct_declarator : declarator",
	"struct_declarator : ':' constant_expression",
	"struct_declarator : declarator ':' constant_expression",
	"enum_specifier : ENUM '{' enumerator_list '}'",
	"enum_specifier : ENUM identifier '{' enumerator_list '}'",
	"enum_specifier : ENUM identifier",
	"enumerator_list : enumerator",
	"enumerator_list : enumerator_list ',' enumerator",
	"enumerator : IDENTIFIER",
	"enumerator : IDENTIFIER '=' constant_expression",
	"declarator : direct_declarator NS_direct_decl",
	"declarator : pointer direct_declarator NS_ptr_decl",
	"direct_declarator : IDENTIFIER",
	"direct_declarator : '(' declarator ')'",
	"direct_declarator : direct_declarator '[' ']'",
	"direct_declarator : direct_declarator '[' constant_expression ']'",
	"direct_declarator : direct_declarator NS_scope_push '(' parameter_type_list ')' NS_scope_pop",
	"direct_declarator : direct_declarator NS_scope_push '(' ')' NS_scope_pop",
	"direct_declarator : direct_declarator NS_scope_push '(' identifier_list ')' NS_scope_pop",
	"function_declarator : direct_function_declarator NS_direct_decl",
	"function_declarator : pointer direct_function_declarator NS_ptr_decl",
	"direct_function_declarator : direct_declarator NS_scope_push '(' parameter_type_list ')'",
	"direct_function_declarator : direct_declarator NS_scope_push '(' ')'",
	"direct_function_declarator : direct_declarator NS_scope_push '(' identifier_list ')'",
	"pointer : '*'",
	"pointer : '*' type_qualifier_list",
	"pointer : '*' pointer",
	"pointer : '*' type_qualifier_list pointer",
	"type_qualifier_list : type_qualifier",
	"type_qualifier_list : type_qualifier_list type_qualifier",
	"parameter_type_list : parameter_list",
	"parameter_type_list : parameter_list ',' ELIPSIS",
	"parameter_list : parameter_declaration",
	"parameter_list : parameter_list ',' parameter_declaration",
	"parameter_declaration : NS_new_parm declaration_specifiers declarator NS_td",
	"parameter_declaration : NS_new_parm declaration_specifiers NS_td",
	"parameter_declaration : NS_new_parm declaration_specifiers abstract_declarator NS_td",
	"identifier_list : IDENTIFIER",
	"identifier_list : identifier_list ',' IDENTIFIER",
	"initializer : conditional_expression",
	"initializer : '{' initializer_list '}'",
	"initializer : '{' initializer_list ',' '}'",
	"initializer_list : initializer",
	"initializer_list : initializer_list ',' initializer",
	"type_name : specifier_qualifier_list NS_td",
	"type_name : specifier_qualifier_list NS_td abstract_declarator",
	"abstract_declarator : pointer",
	"abstract_declarator : direct_abstract_declarator",
	"abstract_declarator : pointer direct_abstract_declarator",
	"direct_abstract_declarator : '(' abstract_declarator ')'",
	"direct_abstract_declarator : '[' ']'",
	"direct_abstract_declarator : '[' constant_expression ']'",
	"direct_abstract_declarator : direct_abstract_declarator '[' ']'",
	"direct_abstract_declarator : direct_abstract_declarator '[' constant_expression ']'",
	"direct_abstract_declarator : '(' ')'",
	"direct_abstract_declarator : '(' parameter_type_list ')'",
	"direct_abstract_declarator : direct_abstract_declarator '(' ')'",
	"direct_abstract_declarator : direct_abstract_declarator '(' parameter_type_list ')'",
	"statement : labeled_statement",
	"statement : compound_statement",
	"statement : expression_statement",
	"statement : selection_statement",
	"statement : iteration_statement",
	"statement : jump_statement",
	"labeled_statement : identifier ':' statement",
	"labeled_statement : CASE constant_expression ':' statement",
	"labeled_statement : DEFAULT ':' statement",
	"expression_statement : ';'",
	"expression_statement : expression ';'",
	"compound_statement : '{'",
	"compound_statement : '{' '}'",
	"statement_list : statement",
	"statement_list : statement_list statement",
	"selection_statement : IF '(' expression ')' statement",
	"selection_statement : IF '(' expression ')' statement ELSE statement",
	"selection_statement : SWITCH '(' expression ')' statement",
	"iteration_statement : WHILE '(' expression ')' statement",
	"iteration_statement : DO statement WHILE '(' expression ')' ';'",
	"iteration_statement : FOR '(' ';' ';' ')' statement",
	"iteration_statement : FOR '(' ';' ';' expression ')' statement",
	"iteration_statement : FOR '(' ';' expression ';' ')' statement",
	"iteration_statement : FOR '(' ';' expression ';' expression ')' statement",
	"iteration_statement : FOR '(' expression ';' ';' ')' statement",
	"iteration_statement : FOR '(' expression ';' ';' expression ')' statement",
	"iteration_statement : FOR '(' expression ';' expression ';' ')' statement",
	"iteration_statement : FOR '(' expression ';' expression ';' expression ')' statement",
	"jump_statement : GOTO identifier ';'",
	"jump_statement : CONTINUE ';'",
	"jump_statement : BREAK ';'",
	"jump_statement : RETURN ';'",
	"jump_statement : RETURN expression ';'",
	"expression : assignment_expression",
	"expression : expression ',' assignment_expression",
	"assignment_expression : conditional_expression",
	"assignment_expression : unary_expression assignment_operator assignment_expression",
	"assignment_operator : '='",
	"assignment_operator : MUL_ASSIGN",
	"assignment_operator : DIV_ASSIGN",
	"assignment_operator : MOD_ASSIGN",
	"assignment_operator : ADD_ASSIGN",
	"assignment_operator : SUB_ASSIGN",
	"assignment_operator : LEFT_ASSIGN",
	"assignment_operator : RIGHT_ASSIGN",
	"assignment_operator : AND_ASSIGN",
	"assignment_operator : XOR_ASSIGN",
	"assignment_operator : OR_ASSIGN",
	"conditional_expression : logical_or_expression",
	"conditional_expression : logical_or_expression '?' expression ':' conditional_expression",
	"constant_expression : conditional_expression",
	"logical_or_expression : logical_and_expression",
	"logical_or_expression : logical_or_expression OR_OP logical_and_expression",
	"logical_and_expression : inclusive_or_expression",
	"logical_and_expression : logical_and_expression AND_OP inclusive_or_expression",
	"inclusive_or_expression : exclusive_or_expression",
	"inclusive_or_expression : inclusive_or_expression '|' exclusive_or_expression",
	"exclusive_or_expression : and_expression",
	"exclusive_or_expression : exclusive_or_expression '^' and_expression",
	"and_expression : equality_expression",
	"and_expression : and_expression '&' equality_expression",
	"equality_expression : relational_expression",
	"equality_expression : equality_expression EQ_OP relational_expression",
	"equality_expression : equality_expression NE_OP relational_expression",
	"relational_expression : shift_expression",
	"relational_expression : relational_expression '<' shift_expression",
	"relational_expression : relational_expression '>' shift_expression",
	"relational_expression : relational_expression LE_OP shift_expression",
	"relational_expression : relational_expression GE_OP shift_expression",
	"shift_expression : additive_expression",
	"shift_expression : shift_expression LEFT_OP additive_expression",
	"shift_expression : shift_expression RIGHT_OP additive_expression",
	"additive_expression : multiplicative_expression",
	"additive_expression : additive_expression '+' multiplicative_expression",
	"additive_expression : additive_expression '-' multiplicative_expression",
	"multiplicative_expression : cast_expression",
	"multiplicative_expression : multiplicative_expression '*' cast_expression",
	"multiplicative_expression : multiplicative_expression '/' cast_expression",
	"multiplicative_expression : multiplicative_expression '%' cast_expression",
	"cast_expression : unary_expression",
	"cast_expression : '(' type_name ')' cast_expression",
	"unary_expression : postfix_expression",
	"unary_expression : INC_OP unary_expression",
	"unary_expression : DEC_OP unary_expression",
	"unary_expression : unary_operator cast_expression",
	"unary_expression : SIZEOF unary_expression",
	"unary_expression : SIZEOF '(' type_name ')'",
	"unary_operator : '&'",
	"unary_operator : '*'",
	"unary_operator : '+'",
	"unary_operator : '-'",
	"unary_operator : '~'",
	"unary_operator : '!'",
	"postfix_expression : primary_expression",
	"postfix_expression : postfix_expression '[' expression ']'",
	"postfix_expression : postfix_expression '(' ')'",
	"postfix_expression : postfix_expression '(' argument_expression_list ')'",
	"postfix_expression : postfix_expression '.' identifier",
	"postfix_expression : postfix_expression PTR_OP identifier",
	"postfix_expression : postfix_expression INC_OP",
	"postfix_expression : postfix_expression DEC_OP",
	"primary_expression : IDENTIFIER",
	"primary_expression : constant",
	"primary_expression : STRING",
	"primary_expression : '(' expression ')'",
	"argument_expression_list : assignment_expression",
	"argument_expression_list : argument_expression_list ',' assignment_expression",
	"constant : INTEGER_CONSTANT",
	"constant : CHARACTER_CONSTANT",
	"constant : FLOATING_CONSTANT",
	"constant : ENUMERATION_CONSTANT",
};
#endif /* YYDEBUG */
/* 
 *	Copyright 1987 Silicon Graphics, Inc. - All Rights Reserved
 */

/* #ident	"@(#)yacc:yaccpar	1.10" */
#ident	"$Revision: 1.5 $"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** global variables used by the parser
*/
YYSTYPE yyv[ YYMAXDEPTH ];	/* value stack */
int yys[ YYMAXDEPTH ];		/* state stack */

YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ YYMAXDEPTH ] )	/* room on stack? */
		{
			yyerror( "yacc stack overflow" );
			YYABORT;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 3:
# line 143 "grammar.y"
{ scope_push(); td(); } break;
case 4:
# line 145 "grammar.y"
{ scope_pop(); } break;
case 12:
# line 187 "grammar.y"
{yyval.nod = id_from_typedef(yypvt[-1].typ);} break;
case 17:
# line 207 "grammar.y"
{function_def(yypvt[-0].sym);} break;
case 18:
# line 208 "grammar.y"
{typed_external_decl(yypvt[-0].sym);} break;
case 21:
# line 214 "grammar.y"
{KnR_params(yypvt[-1].sym, yypvt[-0].sym);} break;
case 23:
# line 219 "grammar.y"
{yyval.sym = function_spec(0, yypvt[-1].nod);} break;
case 24:
# line 220 "grammar.y"
{yyval.sym = function_spec(yypvt[-2].typ, yypvt[-1].nod);} break;
case 26:
# line 228 "grammar.y"
{yyval.sym = novar_declaration(yypvt[-2].typ);} break;
case 27:
# line 230 "grammar.y"
{yyval.sym = var_declaration(yypvt[-3].typ, yypvt[-2].nod);} break;
case 30:
# line 239 "grammar.y"
{yyval.sym = concat_symbols(yypvt[-1].sym,yypvt[-0].sym);} break;
case 31:
# line 243 "grammar.y"
{yyval.typ = typeof_typemod(yypvt[-0].val);} break;
case 32:
# line 244 "grammar.y"
{yyval.typ = concat_types(typeof_typemod(yypvt[-1].val), yypvt[-0].typ);} break;
case 34:
# line 246 "grammar.y"
{yyval.typ = concat_types(yypvt[-1].typ, yypvt[-0].typ);} break;
case 35:
# line 247 "grammar.y"
{yyval.typ = typeof_typemod(yypvt[-0].val);} break;
case 36:
# line 248 "grammar.y"
{yyval.typ = concat_types(typeof_typemod(yypvt[-1].val), yypvt[-0].typ);} break;
case 37:
# line 252 "grammar.y"
{yyval.val = TYPEMOD_TYPEDEF;} break;
case 38:
# line 253 "grammar.y"
{yyval.val = TYPEMOD_EXTERN;} break;
case 39:
# line 254 "grammar.y"
{yyval.val = TYPEMOD_STATIC;} break;
case 40:
# line 255 "grammar.y"
{yyval.val = TYPEMOD_AUTO;} break;
case 41:
# line 256 "grammar.y"
{yyval.val = TYPEMOD_REGISTER;} break;
case 42:
# line 263 "grammar.y"
{yyval.typ = yypvt[-0].typ;} break;
case 43:
# line 264 "grammar.y"
{yyval.typ = typeof_typemod(yypvt[-0].val);} break;
case 44:
# line 268 "grammar.y"
{yyval.typ = typeof_void();} break;
case 45:
# line 269 "grammar.y"
{yyval.typ = typeof_char();} break;
case 46:
# line 270 "grammar.y"
{yyval.typ = typeof_int();} break;
case 47:
# line 271 "grammar.y"
{yyval.typ = typeof_float();} break;
case 48:
# line 272 "grammar.y"
{yyval.typ = typeof_double();} break;
case 50:
# line 274 "grammar.y"
{yyval.typ = typeof_specifier(yypvt[-0].sym);} break;
case 51:
# line 275 "grammar.y"
{yyval.typ = typeof_specifier(yypvt[-0].sym);} break;
case 52:
# line 279 "grammar.y"
{yyval.val = TYPEMOD_SHORT;} break;
case 53:
# line 280 "grammar.y"
{yyval.val = TYPEMOD_LONG;} break;
case 54:
# line 281 "grammar.y"
{yyval.val = TYPEMOD_SIGNED;} break;
case 55:
# line 282 "grammar.y"
{yyval.val = TYPEMOD_UNSIGNED;} break;
case 56:
# line 286 "grammar.y"
{yyval.val = TYPEMOD_CONST;} break;
case 57:
# line 287 "grammar.y"
{yyval.val = TYPEMOD_VOLATILE;} break;
case 58:
# line 292 "grammar.y"
{ yyval.sym = anonymous_rec(yypvt[-5].val, yypvt[-2].sym);} break;
case 59:
# line 294 "grammar.y"
{ yyval.sym = named_rec(yypvt[-6].val, yypvt[-5].nod, yypvt[-2].sym);} break;
case 60:
# line 295 "grammar.y"
{ yyval.sym = rec_reference(yypvt[-1].val, yypvt[-0].nod);} break;
case 61:
# line 299 "grammar.y"
{yyval.val = 0;} break;
case 62:
# line 300 "grammar.y"
{yyval.val = 1;} break;
case 64:
# line 305 "grammar.y"
{yyval.sym = concat_symbols(yypvt[-1].sym,yypvt[-0].sym);} break;
case 66:
# line 310 "grammar.y"
{yyval.nod = new_node(_List, yypvt[-2].nod, yypvt[-0].nod);} break;
case 68:
# line 315 "grammar.y"
{yyval.nod = new_node(_Assign, yypvt[-4].nod, yypvt[-1].nod);} break;
case 69:
# line 321 "grammar.y"
{yyval.sym = field_declaration(yypvt[-3].typ, yypvt[-2].nod);} break;
case 70:
# line 325 "grammar.y"
{yyval.typ = typeof_typespec(yypvt[-0].typ);} break;
case 71:
# line 326 "grammar.y"
{yyval.typ = typeof_typespec(concat_types(yypvt[-1].typ, yypvt[-0].typ));} break;
case 72:
# line 327 "grammar.y"
{yyval.typ = typeof_typespec(typeof_typemod(yypvt[-0].val));} break;
case 73:
# line 328 "grammar.y"
{yyval.typ = typeof_typespec(concat_types(typeof_typemod(yypvt[-1].val),yypvt[-0].typ));} break;
case 75:
# line 333 "grammar.y"
{yyval.nod = new_node(_List, yypvt[-2].nod, yypvt[-0].nod);} break;
case 77:
# line 338 "grammar.y"
{yyval.nod = new_node(_Bit_Field, 0, yypvt[-0].nod);} break;
case 78:
# line 339 "grammar.y"
{yyval.nod = new_node(_Bit_Field, yypvt[-2].nod, yypvt[-0].nod);} break;
case 79:
# line 343 "grammar.y"
{yyval.sym = anonymous_enum(yypvt[-1].sym);} break;
case 80:
# line 344 "grammar.y"
{yyval.sym = named_enum(yypvt[-3].nod, yypvt[-1].sym);} break;
case 81:
# line 345 "grammar.y"
{yyval.sym = enum_reference(yypvt[-0].nod);} break;
case 83:
# line 350 "grammar.y"
{yyval.sym = concat_symbols(yypvt[-2].sym,yypvt[-0].sym);} break;
case 84:
# line 354 "grammar.y"
{yyval.sym = grok_enumerator(yypvt[-0].nod,0);} break;
case 85:
# line 355 "grammar.y"
{yyval.sym = grok_enumerator(yypvt[-2].nod,yypvt[-0].nod);} break;
case 87:
# line 360 "grammar.y"
{yyval.nod = access_to(yypvt[-2].nod, yypvt[-1].nod);} break;
case 89:
# line 365 "grammar.y"
{yyval.nod = yypvt[-1].nod;} break;
case 90:
# line 366 "grammar.y"
{yyval.nod = new_node(_Array_Index, yypvt[-2].nod, 0);} break;
case 91:
# line 367 "grammar.y"
{yyval.nod = new_node(_Array_Index, yypvt[-3].nod, yypvt[-1].nod);} break;
case 92:
# line 370 "grammar.y"
{yyval.nod = new_node(_Func_Call, yypvt[-5].nod, new_node(_Sym,yypvt[-2].sym));} break;
case 93:
# line 372 "grammar.y"
{yyval.nod = new_node(_Func_Call, yypvt[-4].nod, 0);} break;
case 94:
# line 374 "grammar.y"
{yyval.nod = new_node(_Func_Call, yypvt[-5].nod, yypvt[-2].nod);} break;
case 96:
# line 380 "grammar.y"
{yyval.nod = access_to(yypvt[-2].nod, yypvt[-1].nod);} break;
case 97:
# line 385 "grammar.y"
{yyval.nod = new_node(_Func_Call, yypvt[-4].nod, new_node(_Sym,yypvt[-1].sym));} break;
case 98:
# line 387 "grammar.y"
{yyval.nod = new_node(_Func_Call, yypvt[-3].nod, 0);} break;
case 99:
# line 389 "grammar.y"
{yyval.nod = new_node(_Func_Call, yypvt[-4].nod, yypvt[-1].nod);} break;
case 100:
# line 393 "grammar.y"
{yyval.nod = new_node(_Indirect, 0);} break;
case 101:
# line 394 "grammar.y"
{yyval.nod = new_node(_Indirect, 0);} break;
case 102:
# line 395 "grammar.y"
{yyval.nod = new_node(_Indirect, yypvt[-0].nod);} break;
case 103:
# line 396 "grammar.y"
{yyval.nod = new_node(_Indirect, yypvt[-0].nod);} break;
case 105:
# line 401 "grammar.y"
{yyval.val = yypvt[-1].val | yypvt[-0].val;} break;
case 107:
# line 406 "grammar.y"
{yyval.sym = yypvt[-2].sym;} break;
case 109:
# line 411 "grammar.y"
{yyval.sym = concat_symbols(yypvt[-2].sym,yypvt[-0].sym);} break;
case 110:
# line 416 "grammar.y"
{yyval.sym = named_abstract_param(yypvt[-2].typ, yypvt[-1].nod);} break;
case 111:
# line 418 "grammar.y"
{yyval.sym = noname_simple_param(yypvt[-1].typ);} break;
case 112:
# line 420 "grammar.y"
{yyval.sym = noname_abstract_param(yypvt[-2].typ, yypvt[-1].nod);} break;
case 114:
# line 425 "grammar.y"
{yyval.nod = new_node(_List, yypvt[-2].nod, yypvt[-0].nod);} break;
case 116:
# line 430 "grammar.y"
{yyval.nod = new_node(_Aggregate, yypvt[-1].nod);} break;
case 117:
# line 431 "grammar.y"
{yyval.nod = new_node(_Aggregate, new_node(_List, yypvt[-2].nod, 0));} break;
case 119:
# line 436 "grammar.y"
{yyval.nod = new_node(_List, yypvt[-2].nod, yypvt[-0].nod);} break;
case 121:
# line 441 "grammar.y"
{nyi(); yyval.typ = 0;} break;
case 124:
# line 447 "grammar.y"
{yyval.nod = access_to(yypvt[-1].nod, yypvt[-0].nod);} break;
case 125:
# line 451 "grammar.y"
{yyval.nod = yypvt[-1].nod;} break;
case 126:
# line 452 "grammar.y"
{yyval.nod = new_node(_Array_Index, 0, 0);} break;
case 127:
# line 453 "grammar.y"
{yyval.nod = new_node(_Array_Index, 0, yypvt[-1].nod);} break;
case 128:
# line 454 "grammar.y"
{yyval.nod = new_node(_Array_Index, yypvt[-2].nod, 0);} break;
case 129:
# line 455 "grammar.y"
{yyval.nod = new_node(_Array_Index, yypvt[-3].nod, yypvt[-1].nod);} break;
case 130:
# line 456 "grammar.y"
{yyval.nod = new_node(_Func_Call, 0, 0);} break;
case 131:
# line 457 "grammar.y"
{yyval.nod = new_node(_Func_Call, 0, new_node(_Sym,yypvt[-1].sym));} break;
case 132:
# line 458 "grammar.y"
{yyval.nod = new_node(_Func_Call, yypvt[-2].nod, 0);} break;
case 133:
# line 459 "grammar.y"
{yyval.nod = new_node(_Func_Call, yypvt[-3].nod, new_node(_Sym,yypvt[-1].sym));} break;
case 145:
# line 492 "grammar.y"
{yyskip();} break;
case 168:
# line 529 "grammar.y"
{yyval.nod = new_node(_List, yypvt[-2].nod, yypvt[-0].nod);} break;
case 170:
# line 536 "grammar.y"
{yyval.nod = new_node(yypvt[-1].val, yypvt[-2].nod, yypvt[-0].nod);} break;
case 171:
# line 540 "grammar.y"
{yyval.val = _Assign;} break;
case 172:
# line 541 "grammar.y"
{yyval.val = _Mul_Assign;} break;
case 173:
# line 542 "grammar.y"
{yyval.val = _Div_Assign;} break;
case 174:
# line 543 "grammar.y"
{yyval.val = _Mod_Assign;} break;
case 175:
# line 544 "grammar.y"
{yyval.val = _Add_Assign;} break;
case 176:
# line 545 "grammar.y"
{yyval.val = _Sub_Assign;} break;
case 177:
# line 546 "grammar.y"
{yyval.val = _Shl_Assign;} break;
case 178:
# line 547 "grammar.y"
{yyval.val = _Shr_Assign;} break;
case 179:
# line 548 "grammar.y"
{yyval.val = _Band_Assign;} break;
case 180:
# line 549 "grammar.y"
{yyval.val = _Xor_Assign;} break;
case 181:
# line 550 "grammar.y"
{yyval.val = _Bor_Assign;} break;
case 183:
# line 557 "grammar.y"
{yyval.nod = new_node(_Cond, yypvt[-4].nod, yypvt[-2].nod, yypvt[-0].nod);} break;
case 186:
# line 568 "grammar.y"
{yyval.nod = new_node(_Lor, yypvt[-2].nod, yypvt[-0].nod);} break;
case 188:
# line 573 "grammar.y"
{yyval.nod = new_node(_Land, yypvt[-2].nod, yypvt[-0].nod);} break;
case 190:
# line 578 "grammar.y"
{yyval.nod = new_node(_Bor, yypvt[-2].nod, yypvt[-0].nod);} break;
case 192:
# line 583 "grammar.y"
{yyval.nod = new_node(_Xor, yypvt[-2].nod, yypvt[-0].nod);} break;
case 194:
# line 588 "grammar.y"
{yyval.nod = new_node(_Band, yypvt[-2].nod, yypvt[-0].nod);} break;
case 196:
# line 593 "grammar.y"
{yyval.nod = new_node(_Eq, yypvt[-2].nod, yypvt[-0].nod);} break;
case 197:
# line 594 "grammar.y"
{yyval.nod = new_node(_Ne, yypvt[-2].nod, yypvt[-0].nod);} break;
case 199:
# line 599 "grammar.y"
{yyval.nod = new_node(_Lt, yypvt[-2].nod, yypvt[-0].nod);} break;
case 200:
# line 600 "grammar.y"
{yyval.nod = new_node(_Gt, yypvt[-2].nod, yypvt[-0].nod);} break;
case 201:
# line 601 "grammar.y"
{yyval.nod = new_node(_Le, yypvt[-2].nod, yypvt[-0].nod);} break;
case 202:
# line 602 "grammar.y"
{yyval.nod = new_node(_Ge, yypvt[-2].nod, yypvt[-0].nod);} break;
case 204:
# line 607 "grammar.y"
{yyval.nod = new_node(_Shl, yypvt[-2].nod, yypvt[-0].nod);} break;
case 205:
# line 608 "grammar.y"
{yyval.nod = new_node(_Shr, yypvt[-2].nod, yypvt[-0].nod);} break;
case 207:
# line 613 "grammar.y"
{yyval.nod = new_node(_Add, yypvt[-2].nod, yypvt[-0].nod);} break;
case 208:
# line 614 "grammar.y"
{yyval.nod = new_node(_Sub, yypvt[-2].nod, yypvt[-0].nod);} break;
case 210:
# line 619 "grammar.y"
{yyval.nod = new_node(_Mul, yypvt[-2].nod, yypvt[-0].nod);} break;
case 211:
# line 620 "grammar.y"
{yyval.nod = new_node(_Div, yypvt[-2].nod, yypvt[-0].nod);} break;
case 212:
# line 621 "grammar.y"
{yyval.nod = new_node(_Rem, yypvt[-2].nod, yypvt[-0].nod);} break;
case 214:
# line 626 "grammar.y"
{yyval.nod = new_node(_Type_Cast, new_node(_Type, yypvt[-2].typ), yypvt[-0].nod);} break;
case 216:
# line 632 "grammar.y"
{yyval.nod = new_node(_Pre_Inc, yypvt[-0].nod);} break;
case 217:
# line 633 "grammar.y"
{yyval.nod = new_node(_Pre_Dec, yypvt[-0].nod);} break;
case 218:
# line 634 "grammar.y"
{yyval.nod = new_node(yypvt[-1].val, yypvt[-0].nod);} break;
case 219:
# line 635 "grammar.y"
{yyval.nod = new_node(_Sizeof, yypvt[-0].nod);} break;
case 220:
# line 636 "grammar.y"
{yyval.nod = new_node(_Sizeof, new_node(_Type, yypvt[-1].typ));} break;
case 221:
# line 641 "grammar.y"
{yyval.val = _Addrof;} break;
case 222:
# line 642 "grammar.y"
{yyval.val = _Indirect;} break;
case 223:
# line 643 "grammar.y"
{yyval.val = _Unary_Plus;} break;
case 224:
# line 644 "grammar.y"
{yyval.val = _Unary_Minus;} break;
case 225:
# line 645 "grammar.y"
{yyval.val = _Ones_Complement;} break;
case 226:
# line 646 "grammar.y"
{yyval.val = _Not;} break;
case 228:
# line 652 "grammar.y"
{yyval.nod = new_node(_Array_Index, yypvt[-3].nod, yypvt[-1].nod);} break;
case 229:
# line 653 "grammar.y"
{yyval.nod = new_node(_Func_Call, yypvt[-2].nod, 0);} break;
case 230:
# line 654 "grammar.y"
{yyval.nod = new_node(_Func_Call, yypvt[-3].nod, yypvt[-1].nod);} break;
case 231:
# line 655 "grammar.y"
{yyval.nod = new_node(_Dot_Selected, yypvt[-2].nod, yypvt[-0].nod);} break;
case 232:
# line 656 "grammar.y"
{yyval.nod = new_node(_Arrow_Selected, yypvt[-2].nod, yypvt[-0].nod);} break;
case 233:
# line 657 "grammar.y"
{yyval.nod = new_node(_Post_Inc, yypvt[-1].nod);} break;
case 234:
# line 658 "grammar.y"
{yyval.nod = new_node(_Post_Dec, yypvt[-1].nod);} break;
case 238:
# line 665 "grammar.y"
{yyval.nod = yypvt[-1].nod;} break;
case 240:
# line 670 "grammar.y"
{yyval.nod = new_node(_List, yypvt[-2].nod, yypvt[-0].nod);} break;
	}
	goto yystack;		/* reset registers in driver code */
}
